//----------------------------------------------------------------------------
// UPTShellUtils.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: UPTShellUtils.pas
//----------------------------------------------------------------------------
#ifndef UPTShellUtilsHPP
#define UPTShellUtilsHPP
//----------------------------------------------------------------------------
#include <UPTShell95.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <Messages.hpp>
#include <OLE2.hpp>
#include <Dialogs.hpp>
#include <ShellAPI.hpp>
#include <SysUtils.hpp>
#include <Windows.hpp>
#include <System.hpp>
namespace Uptshellutils
{
//-- type declarations -------------------------------------------------------
enum TCSIDL { csidlDesktop, csidl_None1, csidlPrograms, csidlControls, csidlPrinters, csidlPersonal, 
	csidlFavorites, csidlStartup, csidlRecent, csidlSendTo, csidlBitBucket, csidlStartMenu, csidl_None2, 
	csidl_None3, csidl_None4, csidl_None5, csidlDesktopDirectory, csidlDrives, csidlNetwork, csidlNethood, 
	csidlFonts, csidlTemplates, csidlCommonStartMenu, csidlCommonPrograms, csidlCommonStartup, csidlCommonDesktopDirectory, 
	csidlAppData, csidlPrintHood, csidlNone };

#pragma pack(push, 1)
struct TPTModuleVersion
{
	
	union
	{
		struct 
		{
			int _3;
			int version;
			
		};
		struct 
		{
			Word _1;
			Word _2;
			Word minor;
			Word major;
			
		};
		struct 
		{
			int dw1;
			int dw2;
			
		};
		struct 
		{
			Word w1;
			Word w2;
			Word w3;
			Word w4;
			
		};
		
	};
} ;
#pragma pack(pop)

typedef TPTModuleVersion *PPTModuleVersion;

enum TPTFriendlyNameFlags { ptfnNormal, ptfnInFolder, ptfnForParsing };

enum TPTShellIconSize { ptsizSmall, ptsizLarge };

class __declspec(delphiclass) TPTIdListArray;
class __declspec(pascalimplementation) TPTIdListArray : public System::TObject
{
	typedef System::TObject inherited;
	
protected:
	Uptshell95::TItemIDList *mPidl;
	Uptshell95::TItemIDList *mLastItem;
	int __fastcall GetCount(void);
	Uptshell95::PItemIDList __fastcall GetItem(int idx);
	
public:
	__fastcall TPTIdListArray(Uptshell95::PItemIDList p);
	__fastcall virtual ~TPTIdListArray(void);
	Uptshell95::PItemIDList __fastcall GoUp(int items);
	__property int ItemCount = {read=GetCount, nodefault};
	__property Uptshell95::PItemIDList Item[int idx] = {read=GetItem/*, default*/};
};

class __declspec(delphiclass) TPTPidlList;
class __declspec(pascalimplementation) TPTPidlList : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	Classes::TList* FList;
	bool FSorted;
	Uptshell95::IShellFolder* FShellFolder;
	Ole2::IMalloc* FMalloc;
	TDuplicates FDuplicates;
	Uptshell95::PItemIDList __fastcall GetPIDL(int Index);
	void __fastcall SetPIDL(int Index, Uptshell95::PItemIDList PIDL);
	void * __fastcall GetObject(int Index);
	void __fastcall SetObject(int Index, void * aObject);
	void __fastcall SetSorted(bool isSorted);
	int __fastcall GetCount(void);
	int __fastcall GetCapacity(void);
	void __fastcall SetCapacity(int cap);
	
protected:
	bool __fastcall BinarySearch(Uptshell95::PItemIDList const PIDL, int &Index);
	bool __fastcall LinearSearch(Uptshell95::PItemIDList const PIDL, int &Index);
	
public:
	__fastcall TPTPidlList(void);
	__fastcall virtual ~TPTPidlList(void);
	virtual int __fastcall Add(Uptshell95::PItemIDList const PIDL);
	virtual int __fastcall AddObject(Uptshell95::PItemIDList const PIDL, System::TObject* aObject);
	void __fastcall Delete(int index);
	void __fastcall Clear(void);
	int __fastcall IndexOf(Uptshell95::PItemIDList const PIDL);
	void __fastcall Insert(int Index, Uptshell95::PItemIDList Pidl);
	void __fastcall InsertObject(int Index, Uptshell95::PItemIDList Pidl, void * aObject);
	void __fastcall Sort(void);
	__property Uptshell95::PItemIDList PIDLs[int index] = {read=GetPIDL, write=SetPIDL/*, default*/};
	__property void * Objects[int index] = {read=GetObject, write=SetObject};
	__property bool Sorted = {read=FSorted, write=SetSorted, nodefault};
	__property Ole2::IMalloc* Malloc = {read=FMalloc, write=FMalloc, nodefault};
	__property int Count = {read=GetCount, nodefault};
	__property Uptshell95::IShellFolder* ShellFolder = {read=FShellFolder, write=FShellFolder, nodefault
		};
	__property Classes::TDuplicates Duplicates = {read=FDuplicates, write=FDuplicates, nodefault};
	__property int Capacity = {read=GetCapacity, write=SetCapacity, nodefault};
};

enum TLinkDataOption { ldoUseDesc, ldoUseArgs, ldoUseIcon, ldoUseWorkDir, ldoUseHotKey, ldoUseShowCmd 
	};

typedef Set<TLinkDataOption, ldoUseDesc, ldoUseShowCmd>  TLinkDataOptions;

struct TLinkData
{
	System::AnsiString pathName;
	TLinkDataOptions options;
	System::AnsiString desc;
	System::AnsiString args;
	System::AnsiString iconPath;
	int iconIndex;
	System::AnsiString workingDir;
	int showCmd;
	Word hotkey;
	bool noUI;
	Uptshell95::TItemIDList *idList;
	_WIN32_FIND_DATAA w32fd;
} ;

typedef void __fastcall (__closure *TPTDeviceChangeEvent)(System::TObject* ASender, Messages::TMessage 
	&AMessage);

class __declspec(delphiclass) TPTDeviceChangeHandler;
class __declspec(pascalimplementation) TPTDeviceChangeHandler : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	bool FActive;
	HWND FWindowReceiver;
	Classes::TList* FNotifyList;
	
protected:
	void __fastcall DeleteItem(int AItemIndex);
	void __fastcall WndProc(Messages::TMessage &AMessage);
	void __fastcall BroadcastToList(Messages::TMessage &AMessage);
	
public:
	__fastcall TPTDeviceChangeHandler(void);
	__fastcall virtual ~TPTDeviceChangeHandler(void);
	void __fastcall Add(TPTDeviceChangeEvent AToNotify);
	void __fastcall Remove(TPTDeviceChangeEvent AToNotify);
	__property bool Active = {read=FActive, write=FActive, nodefault};
};

//-- var, const, procedure ---------------------------------------------------
#define COMCTL32_VER580 (int)(327760)
#define COMCTL32_VER472 (int)(262216)
#define COMCTL32_VER471 (int)(262215)
#define COMCTL32_VER470 (int)(262214)
#define COMCTL32_VER400 (int)(262144)
extern TPTModuleVersion COMCTL32_VER;
extern int gFlushDriveInfoSem;
#define PTSH_CMDS_DELETE "delete"
#define PTSH_CMDS_PASTE "paste"
#define PTSH_CMDS_CUT "cut"
#define PTSH_CMDS_COPY "copy"
#define PTSH_CMDS_PROPERTIES "properties"
#define PTSH_CMDS_EXPLORE "explore"
#define PTSH_CMDS_OPEN "open"
#define PTSH_CMDS_FIND "find"
#define PTSH_CMDS_LINK "link"
#define PTSH_CMDS_DUN_CREATE "create"
#define PTSH_CMDS_DUN_CONNECT "connect"
#define PTSH_CMDID_FORMAT (char *)(0x23)
#define DBT_DEVNODES_CHANGED (Byte)(7)
#define DBT_QUERYCHANGECONFIG (Byte)(23)
#define DBT_CONFIGCHANGED (Byte)(24)
#define DBT_CONFIGCHANGECANCELED (Byte)(25)
#define DBT_MONITORCHANGE (Byte)(27)
#define DBT_SHELLLOGGEDON (Byte)(32)
#define DBT_CONFIGMGAPI32 (Byte)(34)
#define DBT_VXDINITCOMPLETE (Byte)(35)
#define DBT_VOLLOCKQUERYLOCK (int)(32833)
#define DBT_VOLLOCKLOCKTAKEN (int)(32834)
#define DBT_VOLLOCKLOCKFAILED (int)(32835)
#define DBT_VOLLOCKQUERYUNLOCK (int)(32836)
#define DBT_VOLLOCKLOCKRELEASED (int)(32837)
#define DBT_VOLLOCKUNLOCKFAILED (int)(32838)
#define DBT_NO_DISK_SPACE (Byte)(71)
#define DBT_LOW_DISK_SPACE (Byte)(72)
#define DBT_DEVICEARRIVAL (int)(32768)
#define DBT_DEVICEQUERYREMOVE (int)(32769)
#define DBT_DEVICEQUERYREMOVEFAILED (int)(32770)
#define DBT_DEVICEREMOVEPENDING (int)(32771)
#define DBT_DEVICEREMOVECOMPLETE (int)(32772)
#define DBT_DEVICETYPESPECIFIC (int)(32773)
#define DBT_DEVTYP_OEM (Byte)(0)
#define DBT_DEVTYP_DEVNODE (Byte)(1)
#define DBT_DEVTYP_VOLUME (Byte)(2)
#define DBT_DEVTYP_PORT (Byte)(3)
#define DBT_DEVTYP_NET (Byte)(4)
#define DBT_DEVTYP_DEVICEINTERFACE (Byte)(5)
#define DBT_DEVTYP_HANDLE (Byte)(6)
extern bool __fastcall IsWin95(void);
extern bool __fastcall IsOSR2OrGreater(void);
extern bool __fastcall IsWinNT(void);
extern bool __fastcall IsWin2000(void);
extern bool __fastcall HasWin95Shell(void);
extern bool __fastcall GetModuleVersion(const System::AnsiString aModuleName, TPTModuleVersion &aVersion
	);
extern void * __fastcall ShellMemAlloc(Cardinal size);
extern void * __fastcall ShellMemRealloc(void * p, Cardinal size);
extern void __fastcall ShellMemFree(void * p);
extern Ole2::IMalloc* __fastcall ShellIMalloc(void);
extern long __fastcall ShellGetFolderFromIdList(Uptshell95::PItemIDList p, Uptshell95::IShellFolder* 
	&ish);
extern long __fastcall ShellGetIdListFromPath(const System::AnsiString path, Uptshell95::PItemIDList 
	&p);
extern System::AnsiString __fastcall ShellGetPathFromIdList(Uptshell95::PItemIDList p);
extern System::AnsiString __fastcall ShellGetDisplayPathName( System::AnsiString aPathName);
extern System::AnsiString __fastcall ShellGetSpecialFolderPath(int ahwnd, TCSIDL csidl);
extern long __fastcall ShellGetSpecialFolderIdList(int ahwnd, TCSIDL csidl, Uptshell95::PItemIDList 
	&idlist);
extern int __fastcall ShellGetIconIndex(Uptshell95::PItemIDList absIdList, int uFlags);
extern int __fastcall ShellGetIconIndexFromPath(const System::AnsiString path, int uFlags);
extern int __fastcall ShellGetIconIndexFromExt(const System::AnsiString ext, int uFlags);
extern int __fastcall ShellGetSpecialFolderIconIndex(TCSIDL csidl, int uFlags);
extern TCSIDL __fastcall ShellFindCSIDLFromIdList(Uptshell95::PItemIDList aIdList);
extern System::AnsiString __fastcall ShellGetFriendlyNameFromIdList(Uptshell95::IShellFolder* ishf, 
	Uptshell95::PItemIDList pidl, TPTFriendlyNameFlags flags);
extern int __fastcall ShellGetSystemImageList(TPTShellIconSize aSize);
extern System::AnsiString __fastcall StrretToString(Uptshell95::PItemIDList pidl, const Uptshell95::TStrRet 
	&r);
extern void __fastcall StrretFree(const Uptshell95::TStrRet &r);
extern System::AnsiString __fastcall EnsureTrailingCharDB(const System::AnsiString aSource, char aTrailingChar
	);
extern int __fastcall IdListLen(Uptshell95::PItemIDList pidl);
extern int __fastcall CompareAbsIdLists(Uptshell95::PItemIDList pidl1, Uptshell95::PItemIDList pidl2
	);
extern Uptshell95::PItemIDList __fastcall ConcatIdLists(Ole2::IMalloc* ishm, Uptshell95::PItemIDList 
	aFirst, Uptshell95::PItemIDList aSecond);
extern Uptshell95::PItemIDList __fastcall CopyIdList(Ole2::IMalloc* ishm, Uptshell95::PItemIDList pidl
	);
extern long __fastcall CreateShortcut(const System::AnsiString linkPathName, const TLinkData &linkData
	);
extern long __fastcall CreateQuickShortcut(const System::AnsiString linkPathName, const System::AnsiString 
	targetPathName);
extern long __fastcall ResolveShortcut(const System::AnsiString linkPathName, TLinkData &linkData, bool 
	afWantIdList);
extern bool __fastcall PTClsidFromFileType( System::AnsiString aExtension, _GUID &aCLSID);
extern void __fastcall OleCheck(int code);
extern void __fastcall FlushDriveInfoCache(void);
extern void __fastcall LockFlushDriveInfoCache(void);
extern void __fastcall UnlockFlushDriveInfoCache(void);
extern System::AnsiString __fastcall FormatStrPos( System::AnsiString aFmtStr, const System::AnsiString 
	* data, const int data_Size);
extern void __fastcall ParametizeCmdLineDB(const System::AnsiString ins, Classes::TStrings* outs);
extern System::AnsiString __fastcall TrimRightDB( System::AnsiString Str);
extern void __fastcall CopyCharDB(int &APos, const System::AnsiString ASource,  System::AnsiString &
	ADest);
extern TPTDeviceChangeHandler* __fastcall PTDeviceChangeHandler(void);
extern void __fastcall finalization(void);
//-- template instantiations -------------------------------------------------
template class TLinkDataOptions ;

}	/* namespace Uptshellutils */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Uptshellutils;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// UPTShellUtils
