//----------------------------------------------------------------------------
// UPTSplitter.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: UPTSplitter.pas
//----------------------------------------------------------------------------
#ifndef UPTSplitterHPP
#define UPTSplitterHPP
//----------------------------------------------------------------------------
#include <ExtCtrls.hpp>
#include <UPTFrame.hpp>
#include <CommCtrl.hpp>
#include <Dialogs.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <System.hpp>
namespace Uptsplitter
{
//-- type declarations -------------------------------------------------------
enum TPTSplitterStyle { ptstVertical, ptstHorizontal };

typedef void __fastcall (__closure *TPTSplitterDragEvent)(System::TObject* aSender, int aPosition);

enum TPTFullDragMode { ptfdOff, ptfdOn, ptfdUser };

class __declspec(delphiclass) TPTSplitter;
class __declspec(delphiclass) TPTPane;
class __declspec(pascalimplementation) TPTSplitter : public Controls::TCustomControl
{
	typedef Controls::TCustomControl inherited;
	
private:
	TPTPane* mPanes[2];
	void __fastcall InitPanePos(void);
	
public:
	void __fastcall CreatePanes(void);
	void __fastcall SetActivePane(int paneIndex);
	
private:
	TPTPane* __fastcall GetPane(int idx);
	Graphics::TColor __fastcall GetPaneColor(int idx);
	Uptframe::TPTFrameStyle __fastcall GetPaneStyle(int idx);
	int __fastcall GetPaneMinSize(int idx);
	void __fastcall SetStyle(TPTSplitterStyle aValue);
	void __fastcall SetSplitterWidth(int aValue);
	void __fastcall SetPosition(int aValue);
	void __fastcall SetProportion(float aValue);
	void __fastcall SetPaneColor(int idx, Graphics::TColor aValue);
	void __fastcall SetPaneStyle(int idx, Uptframe::TPTFrameStyle aValue);
	void __fastcall SetPaneMinSize(int idx, int aValue);
	HIDESBASE MESSAGE void __fastcall CMColorChanged(Messages::TMessage &aMsg);
	HIDESBASE MESSAGE void __fastcall WMCancelMode(Messages::TWMNoParams &aMsg);
	HIDESBASE MESSAGE void __fastcall WMSize(Messages::TWMSize &aMsg);
	HIDESBASE MESSAGE void __fastcall WMSetCursor(Messages::TWMSetCursor &aMsg);
	HIDESBASE MESSAGE void __fastcall WMParentNotify(Messages::TWMParentNotify &aMsg);
	MESSAGE void __fastcall WMCaptureChanged(Messages::TMessage &aMsg);
	
protected:
	TPTSplitterStyle mStyle;
	int mSplitterWidth;
	int mPosition;
	TPTFullDragMode mFullDragMode;
	bool mProportional;
	Classes::TNotifyEvent mOnResizeProc;
	TPTSplitterDragEvent mOnSplitterDragProc;
	TPTSplitterDragEvent mOnSplitterDropProc;
	Classes::TNotifyEvent mOnChangeProc;
	float mSplitterProportion;
	bool mfDragging;
	int mDragPosition;
	int mDragOffset;
	TMouseButton mDragButton;
	virtual void __fastcall PaintSizingLine(void);
	HIDESBASE void __fastcall BeginDrag(const tagPOINT &p);
	void __fastcall ContinueDrag(const tagPOINT &p);
	HIDESBASE void __fastcall EndDrag(void);
	void __fastcall SetDragPosition(int pos);
	virtual void __fastcall MouseDown(Controls::TMouseButton aButton, Classes::TShiftState aShift, int 
		x, int y);
	virtual void __fastcall MouseMove(Classes::TShiftState aShift, int x, int y);
	virtual void __fastcall MouseUp(Controls::TMouseButton aButton, Classes::TShiftState aShift, int x, 
		int y);
	bool __fastcall IsFullDrag(void);
	void __fastcall FixProportion(void);
	void __fastcall InternalSetPosition(int aValue, bool aFixProportion);
	virtual void __fastcall Change(void);
	virtual void __fastcall InternalResize(bool aForceResize);
	virtual void __fastcall SplitterDrag(int aPosition);
	virtual void __fastcall SplitterDrop(int aPosition);
	virtual void __fastcall GetChildren(Classes::TGetChildProc Proc);
	virtual Classes::TComponent* __fastcall GetChildOwner(void);
	virtual void __fastcall CreateParams(Controls::TCreateParams &p);
	virtual void __fastcall CreateWnd(void);
	virtual void __fastcall Loaded(void);
	virtual void __fastcall SetName(const System::AnsiString NewName);
	
public:
	__fastcall virtual TPTSplitter(Classes::TComponent* aOwner);
	void __fastcall SwapPanes(DWord afSwapSplit);
	int __fastcall Extent(void);
	__property TPTPane* Pane1 = {read=GetPane, stored=false, index=0, nodefault};
	__property TPTPane* Pane2 = {read=GetPane, stored=false, index=1, nodefault};
	__property float Proportion = {read=mSplitterProportion, write=SetProportion, stored=false, nodefault
		};
	
__published:
	__property Align ;
	__property Visible ;
	__property Enabled ;
	__property Color ;
	__property ParentColor ;
	__property ShowHint ;
	__property ParentShowHint ;
	__property Width ;
	__property Height ;
	__property TPTFullDragMode FullDragMode = {read=mFullDragMode, write=mFullDragMode, default=2};
	__property bool Proportional = {read=mProportional, write=mProportional, default=1};
	__property int Position = {read=mPosition, write=SetPosition, default=65};
	__property TPTSplitterStyle Style = {read=mStyle, write=SetStyle, default=0};
	__property int SplitterWidth = {read=mSplitterWidth, write=SetSplitterWidth, default=3};
	__property Graphics::TColor Pane1Color = {read=GetPaneColor, write=SetPaneColor, stored=false, index=0
		, default=-2147483633};
	__property Uptframe::TPTFrameStyle Pane1FrameStyle = {read=GetPaneStyle, write=SetPaneStyle, stored=false
		, index=0, default=2};
	__property int Pane1MinSize = {read=GetPaneMinSize, write=SetPaneMinSize, stored=false, index=0, default=0
		};
	__property Graphics::TColor Pane2Color = {read=GetPaneColor, write=SetPaneColor, stored=false, index=1
		, default=-2147483633};
	__property Uptframe::TPTFrameStyle Pane2FrameStyle = {read=GetPaneStyle, write=SetPaneStyle, stored=false
		, index=1, default=2};
	__property int Pane2MinSize = {read=GetPaneMinSize, write=SetPaneMinSize, stored=false, index=1, default=0
		};
	__property Classes::TNotifyEvent OnChange = {read=mOnChangeProc, write=mOnChangeProc};
	__property Classes::TNotifyEvent OnResize = {read=mOnResizeProc, write=mOnResizeProc};
	__property TPTSplitterDragEvent OnSplitterDrag = {read=mOnSplitterDragProc, write=mOnSplitterDragProc
		};
	__property TPTSplitterDragEvent OnSplitterDrop = {read=mOnSplitterDropProc, write=mOnSplitterDropProc
		};
	__property OnMouseDown ;
	__property OnMouseUp ;
	__property OnMouseMove ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property TabOrder ;
	__property TabStop ;
	__property OnClick ;
	__property OnDblClick ;
public:
	/* TCustomControl.Destroy */ __fastcall virtual ~TPTSplitter(void) { }
	
public:
	/* TWinControl.CreateParented */ __fastcall TPTSplitter(HWND ParentWindow) : Controls::TCustomControl(
		ParentWindow) { }
	
};

class __declspec(pascalimplementation) TPTPane : public Uptframe::TPTGroup
{
	typedef Uptframe::TPTGroup inherited;
	
private:
	HIDESBASE MESSAGE void __fastcall CMDesignHitTest(Messages::TWMMouse &aMsg);
	
protected:
	int mMinSize;
	int mIndex;
	DWord mfDesignActive;
	virtual void __fastcall Paint(void);
	
public:
	__fastcall virtual TPTPane(Classes::TComponent* aOwner);
	
__published:
	__property FrameStyle ;
	__property int MinSize = {read=mMinSize, write=mMinSize, default=20};
	__property int Index = {read=mIndex, write=mIndex, nodefault};
public:
	/* TCustomControl.Destroy */ __fastcall virtual ~TPTPane(void) { }
	
public:
	/* TWinControl.CreateParented */ __fastcall TPTPane(HWND ParentWindow) : Uptframe::TPTGroup(ParentWindow
		) { }
	
};

//-- var, const, procedure ---------------------------------------------------
extern Graphics::TBitmap* __fastcall Get50PctBmp(void);
extern void __fastcall finalization(void);

}	/* namespace Uptsplitter */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Uptsplitter;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// UPTSplitter
